#include "bsp.h"
#include "bsp_level1.h"
#include <stdio.h>

void spmd_main();
int nprocs;

void main(int argc, char **argv) {
   int i,temp, command_line_opts=1;
  double trash;

  bsp_init(spmd_main,argc,argv);
  
  if (argc!=2) 
    bsp_abort("pass the number of processors to start on the command line");

  if (!sscanf(argv[1],"%d",&nprocs))
    bsp_abort("command line argument not an integer");

  printf("Test of bsp_begin: only one process should print this\n");
    spmd_main();
  printf("Just about to finish, only process zero should "
         "get here (bsp_pid()=%d)\n",bsp_pid());
  exit(0); 
}

void spmd_main() {
  int i;

  bsp_begin(nprocs);
  
  for(i=0;i<bsp_nprocs();i++) {
    if (i==bsp_pid())
      printf("Hello world from process %d of %d\n",bsp_pid(),bsp_nprocs());
    bsp_sync();
  }
  bsp_end();
}
